------------------------------------------------------------------------------------------
-- UI file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Initialize datas
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
function CreateMainWindow()
	local windowWidth = 480;
	local heightWind = 500;

	WhereToPlay=Turbine.UI.Lotro.GoldWindow(); 
	WhereToPlay:SetSize(windowWidth, heightWind); 
	WhereToPlay:SetText(Strings.PluginName); 
	WhereToPlay.Message11=Turbine.UI.Label(); 
	WhereToPlay.Message11:SetParent(WhereToPlay); 
	WhereToPlay.Message11:SetSize(150,10); 
	WhereToPlay.Message11:SetPosition(WhereToPlay:GetWidth()/2 - 75, WhereToPlay:GetHeight() - 18); 
	WhereToPlay.Message11:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	WhereToPlay.Message11:SetText(Strings.PluginText); 
	WhereToPlay:SetZOrder(1);
	WhereToPlay:SetWantsKeyEvents(true);
	WhereToPlay:SetWantsUpdates(true);

	WhereToPlay:SetPosition(settings["windowPosition"]["xPos"], settings["windowPosition"]["yPos"]);
	


	WhereToPlayerDatas=Turbine.UI.Label(); 
	WhereToPlayerDatas:SetParent(WhereToPlay); 
	WhereToPlayerDatas:SetSize(200,20); 
	WhereToPlayerDatas:SetPosition(10, 40); 
	WhereToPlayerDatas:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight); 
	WhereToPlayerDatas:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
	WhereToPlayerDatas:SetForeColor(Turbine.UI.Color.Lime);
	WhereToPlayerDatas:SetText(PlayerName); 

	DisplayRace(windowWidth);
	DisplayClass(windowWidth);

	WhereToPlayerDatas=Turbine.UI.Label(); 
	WhereToPlayerDatas:SetParent(WhereToPlay); 
	WhereToPlayerDatas:SetSize(50,20); 
	WhereToPlayerDatas:SetPosition(windowWidth/2 + 90, 40); 
	WhereToPlayerDatas:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight); 
	WhereToPlayerDatas:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
	WhereToPlayerDatas:SetForeColor(Turbine.UI.Color.White);
	WhereToPlayerDatas:SetText("lvl");

	WhereToPlayerDatas=Turbine.UI.Label(); 
	WhereToPlayerDatas:SetParent(WhereToPlay); 
	WhereToPlayerDatas:SetSize(50,20); 
	WhereToPlayerDatas:SetPosition(windowWidth/2 + 150, 40); 
	WhereToPlayerDatas:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
	WhereToPlayerDatas:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24);
	WhereToPlayerDatas:SetForeColor(Turbine.UI.Color.Gold);
	WhereToPlayerDatas:SetText(PlayerLvl); 


	-- box bleu fond
	WhereToPlayerDatas=Turbine.UI.Label(); 
	WhereToPlayerDatas:SetParent(WhereToPlay); 
	WhereToPlayerDatas:SetSize(430,36); 
	WhereToPlayerDatas:SetPosition(25, 32); 
	WhereToPlayerDatas:SetText(""); 
	WhereToPlayerDatas:SetBackColor(Turbine.UI.Color(1, .2, .5, .75));
	WhereToPlayerDatas:SetZOrder(-2);

	-- box bleu cover black
	WhereToPlayerDatas=Turbine.UI.Label(); 
	WhereToPlayerDatas:SetParent(WhereToPlay); 
	WhereToPlayerDatas:SetSize(428,34); 
	WhereToPlayerDatas:SetPosition(26, 33); 
	WhereToPlayerDatas:SetText(""); 
	WhereToPlayerDatas:SetBackColor(Turbine.UI.Color.Black);
	WhereToPlayerDatas:SetZOrder(-1);


	-- create the viewport control all it needs is size and position as it is simply used to create viewable bounds for our map
	viewport1=Turbine.UI.Control();
	viewport1:SetParent(WhereToPlay);
	viewport1:SetSize(windowWidth - 45, 400);
	viewport1:SetPosition(10, 70);
	-- debug purpose
	-- viewport1:SetBackColor(Turbine.UI.Color.Red);

	-- create the map content for our viewport, again, it only needs size and position as it is just a container for the grid of images
	viewport1.map=Turbine.UI.Control();
	viewport1.map:SetParent(viewport1); -- set the map as a child of the viewport so that it will be bounded by it for drawing purposes
	viewport1.map:SetSize(windowWidth - 45, (113 * 25) + 10); -- we'll use a 5x4 grid but this obviously could be expanded, or even set up as a recycled array of controls
	viewport1.map:SetPosition(0,0); -- we'll start off in the upper left




	-- debug purpose
	--PlayerLvl = 23;
	local valLvl = {};
	local WhereToPlayZoneName = {};
	local posx = 10;
	local posy = 10;

	for i=1, 113 do
		WhereToPlayZoneName[i]=Turbine.UI.Label(); 
		WhereToPlayZoneName[i]:SetParent(viewport1.map); 
		WhereToPlayZoneName[i]:SetSize(318,20); 
		WhereToPlayZoneName[i]:SetPosition(posx, posy); 
		WhereToPlayZoneName[i]:SetTextAlignment(Turbine.UI.ContentAlignment.Middleleft); 
		WhereToPlayZoneName[i]:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19);

		if(ZonesNamesAndLevel["zones" .. i].souCat == false)then
			WhereToPlayZoneName[i]:SetText(ZonesNamesAndLevel["zones" .. i].texte); 
		else
			WhereToPlayZoneName[i]:SetText("    " .. ZonesNamesAndLevel["zones" .. i].texte); 
		end


		-- change the color if the player has the level of the zone to display
		valLvl = ReturnValueLevel(i);

		if(PlayerLvl >= tonumber(valLvl[1]) and PlayerLvl <= tonumber(valLvl[2]))then
			WhereToPlayZoneName[i]:SetBackColor(Turbine.UI.Color( .9, .5, .7, .5));
			WhereToPlayZoneName[i]:SetForeColor(Turbine.UI.Color.Black);
		else
			WhereToPlayZoneName[i]:SetBackColor(Turbine.UI.Color.Black);
			WhereToPlayZoneName[i]:SetForeColor(Turbine.UI.Color.White);
		end
		WhereToPlayZoneName[i]:SetMouseVisible(true);

		
		-- open the window of the map location
		WhereToPlayZoneName[i].MouseClick = function()
			--Turbine.Shell.WriteLine("Click Numero " .. tostring(i));
			if(settings["isMapWindowVisible"]["value"] == true)then
				MapWindow:SetVisible(false);
			end
			CreateMapWindow(i);
			MapWindow:SetVisible(true);
		end


		WhereToPlayZoneLvl=Turbine.UI.Label(); 
		WhereToPlayZoneLvl:SetParent(viewport1.map); 
		WhereToPlayZoneLvl:SetSize(100,20); 
		WhereToPlayZoneLvl:SetPosition(posx + 328, posy); 
		WhereToPlayZoneLvl:SetTextAlignment(Turbine.UI.ContentAlignment.Middleleft); 
		WhereToPlayZoneLvl:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19);
		WhereToPlayZoneLvl:SetForeColor(Turbine.UI.Color.Gold);
		WhereToPlayZoneLvl:SetText("lvl    " .. ZonesNamesAndLevel["zones" .. i].lvl); 

		if(PlayerLvl >= tonumber(valLvl[1]) and PlayerLvl <= tonumber(valLvl[2]))then
			WhereToPlayZoneLvl:SetForeColor(Turbine.UI.Color.Lime);
		else
			WhereToPlayZoneLvl:SetForeColor(Turbine.UI.Color.Gold);
		end

		posy = posy + 25;
	end




	vscroll1=Turbine.UI.Lotro.ScrollBar();
	vscroll1:SetParent(WhereToPlay);
	vscroll1:SetOrientation(Turbine.UI.Orientation.Vertical);
	vscroll1:SetPosition(windowWidth-20, 70);
	vscroll1:SetSize(12,viewport1:GetHeight()); -- set width to 12 since it's a "Lotro" style scrollbar and the height is set to match the control that we will be scrolling
	vscroll1:SetBackColor(Turbine.UI.Color(.1,.1,.2)); -- just to give it a little style
	vscroll1:SetMinimum(0);
	vscroll1:SetMaximum(viewport1.map:GetHeight()-viewport1:GetHeight()); -- we will allow scrolling the height of the map-the viewport height
	vscroll1:SetValue(0); -- set the initial value
	-- set the ValueChanged event handler to take an action when our value changes, in this case, change the map position relative to the viewport
	vscroll1.ValueChanged=function()
		viewport1.map:SetTop(0-vscroll1:GetValue());
	end

	EscapeKeyHandler();
	PositionChangedWindow();
	ClosingTheWindow();
end